
{This program uses Async Professional. Get it at http://tpapro.sourceforge.net/}

unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, Menus, ComCtrls, StdCtrls, AdSelCom, OoMisc, AdPort,
  AdStatLt;

type
  TForm1 = class(TForm)
    StatusBar1: TStatusBar;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Clear1: TMenuItem;
    Exit1: TMenuItem;
    Panel1: TPanel;
    Panel2: TPanel;
    ApdComPort1: TApdComPort;
    ApdSLController1: TApdSLController;
    Memo1: TMemo;
    Board1: TMenuItem;
    ShowDateTime1: TMenuItem;
    SetDateTime1: TMenuItem;
    GroupBox1: TGroupBox;
    ApdStatusLight1: TApdStatusLight;
    ApdStatusLight2: TApdStatusLight;
    ApdStatusLight3: TApdStatusLight;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    GroupBox2: TGroupBox;
    ApdStatusLight4: TApdStatusLight;
    ApdStatusLight5: TApdStatusLight;
    ApdStatusLight6: TApdStatusLight;
    ApdStatusLight7: TApdStatusLight;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    GroupBox3: TGroupBox;
    Edit1: TEdit;
    Button1: TButton;
    GroupBox4: TGroupBox;
    ComboBox2: TComboBox;
    GroupBox5: TGroupBox;
    ComboBox1: TComboBox;
    SDCard1: TMenuItem;
    GetDir1: TMenuItem;
    GetFile1: TMenuItem;
    N1: TMenuItem;
    DeleteFile1: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure ComboBox2Change(Sender: TObject);
    procedure ApdComPort1TriggerAvail(CP: TObject; Count: Word);
    procedure ApdComPort1TriggerData(CP: TObject; TriggerHandle: Word);
    procedure ShowDateTime1Click(Sender: TObject);
    procedure SetDateTime1Click(Sender: TObject);
    procedure Clear1Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Memo1DblClick(Sender: TObject);
    procedure GetDir1Click(Sender: TObject);
    procedure GetFile1Click(Sender: TObject);
    procedure DeleteFile1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    RcvBuf: AnsiString;
    TempString: AnsiString;
    LFTrigger: word;

    function GetFirstToken(S: string; Token: Char): string;
    function StripFirstToken(S: string; Token: Char): string;
    function Int2StrPad0(N: LongInt; Len: Integer): string;
    function CleanString(S: string): string;
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

const
  BaudTable: array[0..9] of integer = (300,600,1200,2400,4800,9600,19200,
  38400,57600,115200);

  NUL = #0;   //null
  SOH = #1;   //start of heading
  STX = #2;   //start of text
  ETX = #3;   //end of text
  EOT = #4;   //end of transmission
  ENQ = #5;   //enquiry
  ACK = #6;   //acknowledge
  BEL = #7;   //bell
  BS  = #8;   //backspace
  HT  = #9;   //horizontal tab
  LF  = #10;  //line feed
  VT  = #11;  //vertical tab
  FF  = #12;  //form feed
  CR  = #13;  //carriage return
  SO  = #14;  //shift out
  SI  = #15;  //shift in
  DLE = #16;  //data link escape
  DC1 = #17;  //device control 1
  DC2 = #18;  //device control 2
  DC3 = #19;  //device control 3
  DC4 = #20;  //device control 4
  NAK = #21;  //negative acknowledge
  SYN = #22;  //synchronous idle
  ETB = #23;  //end of trans. block
  CAN = #24;  //cancel
  EM  = #25;  //end of medium
  SUB = #26;  //substitute
  ESC = #27;  //escape
  FS  = #28;  //file separator
  GS  = #29;  //group separator
  RS  = #30;  //record separator
  US  = #31;  //unit separator
  DEL = #127; //delete

  CRLF = #13+#10;



function TForm1.GetFirstToken(S: string; Token: Char): string;
var
  Count: Integer;
  Temp: string;
begin
  Count := Pos(Token, S);
  if Count < 1 then
  begin
    GetFirstToken := '';
    Exit;
  end;
  Dec(Count);
  Temp := Copy(S,1,Count);
  GetFirstToken := Temp;
end;

function TForm1.StripFirstToken(S: string; Token: Char): string;
var
  Count: integer;
  Temp: string;
begin
  Count := Pos(Token, S);
  if Count = 0 then begin
    StripFirstToken := S;
    Exit;
  end;
  Temp := S;
  Delete(Temp,1,Count);
  StripFirstToken := Temp;
end;

function TForm1.Int2StrPad0(N: LongInt; Len: Integer): string;
var
  S : string;
begin
  Str(N:0,S);
  while Length(S) < Len do
    S := '0' + S;
  Int2StrPad0 := S;
end;

function TForm1.CleanString(S: string): string;
var
  Temp: string;
  i: integer;
  Ch: char;

begin

  for i := 1 to Length(S) do
  begin
    Ch := S[i];
    if Ch > chr(31) then
    begin
      Temp := Temp + Ch;
    end;
  end;
  CleanString := Temp;
end;

//******************************************************************************
procedure TForm1.FormCreate(Sender: TObject);
var
  I: integer;
  TextInBox: string;
  NumInBox: string;
  TheComNum: integer;

begin
  Form1.Caption := 'Serial Utility';
  Panel1.Caption := '';
  Panel2.Caption := '';
  Memo1.Lines.Clear;
  Edit1.Text := '';


  {Uses AdSelCom}
  for I := 1 to 8 do
    if IsPortAvailable(I) then
      ComboBox1.Items.Add(ComName(I));
  if ComboBox1.Items.Count > 0 then
  begin
    ComboBox1.ItemIndex := 0;

    TextInBox := ComboBox1.Items[ComboBox1.ItemIndex];
    NumInBox :=  Copy(TextInBox,4,2);
    TheComNum := StrToInt(NumInBox);
    ApdComPort1.ComNumber := TheComNum;
    ApdSLController1.Monitoring := true;
    ApdComPort1.Open := true;
    LFTrigger := ApdComPort1.AddDataTrigger(LF,false);
  end;

  for I := 0 to 9 do
    ComboBox2.Items.Add(IntToStr(BaudTable[I]));

  ComboBox2.ItemIndex := 5;
  ApdComPort1.Baud := BaudTable[ComboBox2.ItemIndex];
end;

procedure TForm1.Exit1Click(Sender: TObject);
begin
  Close;
end;

procedure TForm1.ComboBox1Change(Sender: TObject);
var
  TextInBox: string;
  NumInBox: string;
  TheComNum: integer;
begin
  try
    ApdComPort1.RemoveTrigger(LFTrigger);
    ApdComPort1.Open := false;
    TextInBox := ComboBox1.Items[ComboBox1.ItemIndex];
    NumInBox :=  Copy(TextInBox,4,2);
    TheComNum := StrToInt(NumInBox);

    ApdComPort1.ComNumber := TheComNum;
    ApdSLController1.Monitoring := true;
    ApdComPort1.Open := true;
    LFTrigger := ApdComPort1.AddDataTrigger(LF,false);
  except
    on E: Exception do MessageDlg(E.Message, mtError, [mbOK], 0);
  end;
end;

procedure TForm1.ComboBox2Change(Sender: TObject);
begin
  ApdComPort1.Baud := BaudTable[ComboBox2.ItemIndex];
end;

procedure TForm1.ApdComPort1TriggerAvail(CP: TObject; Count: Word);
var
  i : Word;
begin
  for i := 1 to Count do
    RcvBuf := RcvBuf + ApdComPort1.GetChar;
end;

procedure TForm1.ApdComPort1TriggerData(CP: TObject; TriggerHandle: Word);
var
  Temp: string;
begin
  if TriggerHandle = LFTrigger then
  begin
    //TempString := Trim(RcvBuf);

    //Temp := CleanString(TempString);
    //if Temp <> '' then
    //begin
      //Temp := Temp + LF;
      //Memo1.Lines.Add(TempString);  // Display the message
    //end;

    Memo1.Lines.Add(RcvBuf);

  end;
  RcvBuf := '';
end;

procedure TForm1.ShowDateTime1Click(Sender: TObject);
begin
  ApdComPort1.PutString('a'+LF);
end;

procedure TForm1.SetDateTime1Click(Sender: TObject);
var
  CurDate: TDateTime;
  WeekDay: integer;
  MyDate: string;
  DoW: string;
  Month: string;
  Day: string;
  Year: string;
  Time: string;
  Hour: string;
  Minute: string;
  Second: string;
begin
  CurDate := Date;
  WeekDay := DayOfWeek(CurDate);
  DoW := IntToStr(WeekDay);
  if (Length(DoW) < 2) then
    DoW := '0'+DoW;

  MyDate := FormatDateTime('yy/mm/dd', Now);
  Year := GetFirstToken(MyDate,'/');
  MyDate := StripFirstToken(MyDate,'/');
  Month := GetFirstToken(MyDate,'/');
  Day := StripFirstToken(MyDate,'/');

  Time := FormatDateTime('hh:nn:ss', Now);
  Hour := GetFirstToken(Time,':');
  Time := StripFirstToken(Time,':');
  Minute := GetFirstToken(Time,':');
  Second := StripFirstToken(Time,':');

  ApdComPort1.PutString('b,'+Year+','+Month+','+Day+','+DoW+','+Hour+','+Minute+','+Second+LF);
end;

procedure TForm1.Clear1Click(Sender: TObject);
begin
  Memo1.Clear;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  if Edit1.Text <> '' then
     ApdComPort1.PutString(Edit1.Text + CRLF)
  else
     StatusBar1.Panels[0].Text := 'Enter command';
end;

procedure TForm1.Memo1DblClick(Sender: TObject);
begin
  //Edit2.Text := Memo1.SelText;
  StatusBar1.Panels[1].Text := Memo1.SelText;
end;

procedure TForm1.GetDir1Click(Sender: TObject);      // Display directory
begin
  ApdComPort1.PutString('x' + CRLF);
  StatusBar1.Panels[1].Text := '';
end;

procedure TForm1.GetFile1Click(Sender: TObject);     // Display file
begin
  if StatusBar1.Panels[1].Text <> '' then
  begin
    ApdComPort1.PutString('y' + StatusBar1.Panels[1].Text + CRLF);
  end
  else
  begin
    StatusBar1.Panels[0].Text := 'Select file from Dir';
  end;
end;

procedure TForm1.DeleteFile1Click(Sender: TObject);  // Erase file
begin
  if StatusBar1.Panels[1].Text <> '' then
  begin
    ApdComPort1.PutString('z' + StatusBar1.Panels[1].Text + CRLF);
  end
  else
  begin
    StatusBar1.Panels[0].Text := 'Select file from Dir';
  end;
end;

end.
