_CoreTimer_Interrupt:
;CoreTimer.c,22 :: 		void CoreTimer_Interrupt() iv IVT_CORE_TIMER ilevel 7 ics ICS_SRS {
RDPGPR	SP, SP
ADDIU	SP, SP, -12
MFC0	R30, 12, 2
SW	R30, 8(SP)
MFC0	R30, 14, 0
SW	R30, 4(SP)
MFC0	R30, 12, 0
SW	R30, 0(SP)
INS	R30, R0, 1, 15
ORI	R30, R0, 7168
MTC0	R30, 12, 0
;CoreTimer.c,25 :: 		msec++;
LW	R2, Offset(_msec+0)(GP)
ADDIU	R2, R2, 1
SW	R2, Offset(_msec+0)(GP)
;CoreTimer.c,26 :: 		if (msec>999) {                   // Check for overflow
SLTIU	R2, R2, 1000
BEQ	R2, R0, L__CoreTimer_Interrupt3
NOP	
J	L_CoreTimer_Interrupt0
NOP	
L__CoreTimer_Interrupt3:
;CoreTimer.c,27 :: 		msec = 0;
SW	R0, Offset(_msec+0)(GP)
;CoreTimer.c,28 :: 		Epoch += 1;                   // Increment Date/Time by 1 second
LW	R2, Offset(_Epoch+0)(GP)
ADDIU	R2, R2, 1
SW	R2, Offset(_Epoch+0)(GP)
;CoreTimer.c,29 :: 		TimerFlag = 1;                // One second flag
ORI	R2, R0, 1
SB	R2, Offset(_TimerFlag+0)(GP)
;CoreTimer.c,32 :: 		}
L_CoreTimer_Interrupt0:
;CoreTimer.c,34 :: 		RegValue = CP0_GET(CP0_COMPARE);  // Get Core Timer current value
MFC0	R30, 11, 0
MOVZ	R2, R30, R0
; RegValue start address is: 12 (R3)
MOVZ	R3, R2, R0
;CoreTimer.c,35 :: 		RegValue += 40000;                // Increment value by 1 ms
ORI	R2, R0, 40000
ADDU	R2, R3, R2
; RegValue end address is: 12 (R3)
;CoreTimer.c,36 :: 		CP0_SET(CP0_COMPARE, RegValue);   // Set Compare register to new value
MOVZ	R30, R2, R0
MTC0	R30, 11, 0
;CoreTimer.c,37 :: 		CTIF_bit = 0;                     // Clear Core Timer interrupt flag
LUI	R2, BitMask(CTIF_bit+0)
ORI	R2, R2, BitMask(CTIF_bit+0)
_SX	8, Offset(CTIF_bit+4), 4
;CoreTimer.c,38 :: 		}
L_end_CoreTimer_Interrupt:
DI	
EHB	
LW	R30, 8(SP)
MTC0	R30, 12, 2
LW	R30, 4(SP)
MTC0	R30, 14, 0
LW	R30, 0(SP)
MTC0	R30, 12, 0
ADDIU	SP, SP, 12
WRPGPR	SP, SP
ERET	
; end of _CoreTimer_Interrupt
_InitCoreTimer:
;CoreTimer.c,41 :: 		void InitCoreTimer(void) {
ADDIU	SP, SP, -8
SW	RA, 0(SP)
;CoreTimer.c,42 :: 		ts1.ss = 0;     // Cold Start values
SW	R25, 4(SP)
SB	R0, Offset(_ts1+0)(GP)
;CoreTimer.c,43 :: 		ts1.mn = 0;
SB	R0, Offset(_ts1+1)(GP)
;CoreTimer.c,44 :: 		ts1.hh = 0;
SB	R0, Offset(_ts1+2)(GP)
;CoreTimer.c,45 :: 		ts1.md = 28;
ORI	R2, R0, 28
SB	R2, Offset(_ts1+3)(GP)
;CoreTimer.c,46 :: 		ts1.wd = 3;
ORI	R2, R0, 3
SB	R2, Offset(_ts1+4)(GP)
;CoreTimer.c,47 :: 		ts1.mo = 6;
ORI	R2, R0, 6
SB	R2, Offset(_ts1+5)(GP)
;CoreTimer.c,48 :: 		ts1.yy = 2012;
ORI	R2, R0, 2012
SH	R2, Offset(_ts1+6)(GP)
;CoreTimer.c,50 :: 		Epoch = Time_dateToEpoch(&ts1);
LUI	R25, #hi_addr(_ts1+0)
ORI	R25, R25, #lo_addr(_ts1+0)
JAL	_Time_dateToEpoch+0
NOP	
SW	R2, Offset(_Epoch+0)(GP)
;CoreTimer.c,52 :: 		CP0_SET(CP0_COUNT, 0);        // Start counter at 0
MOVZ	R2, R0, R0
MOVZ	R30, R2, R0
MTC0	R30, 9, 0
;CoreTimer.c,53 :: 		CP0_SET(CP0_COMPARE, 40000);  // Compare in 1ms
ORI	R2, R0, 40000
MOVZ	R30, R2, R0
MTC0	R30, 11, 0
;CoreTimer.c,55 :: 		CTIP0_bit = 1;  // Set Core Timer priority
LUI	R2, BitMask(CTIP0_bit+0)
ORI	R2, R2, BitMask(CTIP0_bit+0)
_SX	8, Offset(CTIP0_bit+8), 4
;CoreTimer.c,56 :: 		CTIP1_bit = 1;
LUI	R2, BitMask(CTIP1_bit+0)
ORI	R2, R2, BitMask(CTIP1_bit+0)
_SX	8, Offset(CTIP1_bit+8), 4
;CoreTimer.c,57 :: 		CTIP2_bit = 1;
LUI	R2, BitMask(CTIP2_bit+0)
ORI	R2, R2, BitMask(CTIP2_bit+0)
_SX	8, Offset(CTIP2_bit+8), 4
;CoreTimer.c,59 :: 		CTIS0_bit = 1;  // Set Core Timer sub-priority
LUI	R2, BitMask(CTIS0_bit+0)
ORI	R2, R2, BitMask(CTIS0_bit+0)
_SX	8, Offset(CTIS0_bit+8), 4
;CoreTimer.c,60 :: 		CTIS1_bit = 1;
LUI	R2, BitMask(CTIS1_bit+0)
ORI	R2, R2, BitMask(CTIS1_bit+0)
_SX	8, Offset(CTIS1_bit+8), 4
;CoreTimer.c,62 :: 		CTIF_bit = 0;  // Clear Core Timer interrupt flag
LUI	R2, BitMask(CTIF_bit+0)
ORI	R2, R2, BitMask(CTIF_bit+0)
_SX	8, Offset(CTIF_bit+4), 4
;CoreTimer.c,63 :: 		CTIE_bit = 1;  // Enable Core Timer interrupts
LUI	R2, BitMask(CTIE_bit+0)
ORI	R2, R2, BitMask(CTIE_bit+0)
_SX	8, Offset(CTIE_bit+8), 4
;CoreTimer.c,64 :: 		}
L_end_InitCoreTimer:
LW	R25, 4(SP)
LW	RA, 0(SP)
ADDIU	SP, SP, 8
JR	RA
NOP	
; end of _InitCoreTimer
_TimerCheck:
;CoreTimer.c,67 :: 		void TimerCheck() {
ADDIU	SP, SP, -12
SW	RA, 0(SP)
;CoreTimer.c,68 :: 		if (TimerFlag == 1) {
SW	R25, 4(SP)
SW	R26, 8(SP)
LBU	R3, Offset(_TimerFlag+0)(GP)
ORI	R2, R0, 1
BEQ	R3, R2, L__TimerCheck6
NOP	
J	L_TimerCheck1
NOP	
L__TimerCheck6:
;CoreTimer.c,69 :: 		TimerFlag = 0;  // Reset timer flag
SB	R0, Offset(_TimerFlag+0)(GP)
;CoreTimer.c,70 :: 		Time_epochToDate(Epoch, &ts1);  // Update date/time values each second
LUI	R26, #hi_addr(_ts1+0)
ORI	R26, R26, #lo_addr(_ts1+0)
LW	R25, Offset(_Epoch+0)(GP)
JAL	_Time_epochToDate+0
NOP	
;CoreTimer.c,75 :: 		}
L_TimerCheck1:
;CoreTimer.c,76 :: 		}
L_end_TimerCheck:
LW	R26, 8(SP)
LW	R25, 4(SP)
LW	RA, 0(SP)
ADDIU	SP, SP, 12
JR	RA
NOP	
; end of _TimerCheck
