_UART1_Interrupt:
;UART1.c,52 :: 		void UART1_Interrupt() iv IVT_UART_1 ilevel 7 ics ICS_AUTO {
RDPGPR	SP, SP
ADDIU	SP, SP, -16
SW	R30, 12(SP)
MFC0	R30, 12, 2
SW	R30, 8(SP)
MFC0	R30, 14, 0
SW	R30, 4(SP)
MFC0	R30, 12, 0
SW	R30, 0(SP)
INS	R30, R0, 1, 15
ORI	R30, R0, 7168
MTC0	R30, 12, 0
;UART1.c,56 :: 		if (URXDA_bit) {
_LX	, 4
EXT	R2, R2, BitPos(URXDA_bit+0), 1
BNE	R2, R0, L__UART1_Interrupt61
NOP	
J	L_UART1_Interrupt0
NOP	
L__UART1_Interrupt61:
;UART1.c,57 :: 		R_data = U1RXREG;              // Fetch a byte from receive register
; R_data start address is: 16 (R4)
LW	R4, Offset(U1RXREG+0)(GP)
;UART1.c,59 :: 		RxQ.RxQueue[RxQ.RxIn++] = R_data;      // Put it into the recirculating buffer
LH	R3, Offset(_RxQ+0)(GP)
LUI	R2, #hi_addr(_RxQ+4)
ORI	R2, R2, #lo_addr(_RxQ+4)
ADDU	R2, R2, R3
SB	R4, 0(R2)
; R_data end address is: 16 (R4)
LH	R2, Offset(_RxQ+0)(GP)
ADDIU	R2, R2, 1
SH	R2, Offset(_RxQ+0)(GP)
;UART1.c,60 :: 		if (RxQ.RxIn > (rxqsize-1))    // Adjust pointer if necessary
SEH	R2, R2
SLTI	R2, R2, 64
BEQ	R2, R0, L__UART1_Interrupt62
NOP	
J	L_UART1_Interrupt1
NOP	
L__UART1_Interrupt62:
;UART1.c,61 :: 		RxQ.RxIn = 0;
SH	R0, Offset(_RxQ+0)(GP)
L_UART1_Interrupt1:
;UART1.c,62 :: 		U1RXIF_bit = 0;                // Clear the receive interrupt flag
LUI	R2, BitMask(U1RXIF_bit+0)
ORI	R2, R2, BitMask(U1RXIF_bit+0)
_SX	8, Offset(U1RXIF_bit+4), 4
;UART1.c,64 :: 		} else {
J	L_UART1_Interrupt2
NOP	
L_UART1_Interrupt0:
;UART1.c,65 :: 		T_data = XmtBuf[XmtBufPtr++];  // Get a byte from the transmit buffer
LBU	R3, Offset(_XmtBufPtr+0)(GP)
LW	R2, Offset(_XmtBuf+0)(GP)
ADDU	R2, R2, R3
LBU	R3, 0(R2)
; T_data start address is: 16 (R4)
ANDI	R4, R3, 255
LBU	R2, Offset(_XmtBufPtr+0)(GP)
ADDIU	R2, R2, 1
SB	R2, Offset(_XmtBufPtr+0)(GP)
;UART1.c,66 :: 		if (T_data == NUL) {           // If it is the end of message marker
ANDI	R2, R3, 255
BEQ	R2, R0, L__UART1_Interrupt63
NOP	
J	L_UART1_Interrupt3
NOP	
L__UART1_Interrupt63:
; T_data end address is: 16 (R4)
;UART1.c,67 :: 		U1TXIE_bit = 0;            // Disable transmitter interrupts
LUI	R2, BitMask(U1TXIE_bit+0)
ORI	R2, R2, BitMask(U1TXIE_bit+0)
_SX	8, Offset(U1TXIE_bit+4), 4
;UART1.c,68 :: 		} else {
J	L_UART1_Interrupt4
NOP	
L_UART1_Interrupt3:
;UART1.c,69 :: 		U1TXREG = T_data;          // Transfer data byte to transmit register
; T_data start address is: 16 (R4)
ANDI	R2, R4, 255
; T_data end address is: 16 (R4)
SW	R2, Offset(U1TXREG+0)(GP)
;UART1.c,70 :: 		U1TXIF_bit = 0;            // Clear transmit interrupt flag
LUI	R2, BitMask(U1TXIF_bit+0)
ORI	R2, R2, BitMask(U1TXIF_bit+0)
_SX	8, Offset(U1TXIF_bit+4), 4
;UART1.c,71 :: 		}
L_UART1_Interrupt4:
;UART1.c,72 :: 		}
L_UART1_Interrupt2:
;UART1.c,73 :: 		}
L_end_UART1_Interrupt:
DI	
EHB	
LW	R30, 8(SP)
MTC0	R30, 12, 2
LW	R30, 4(SP)
MTC0	R30, 14, 0
LW	R30, 0(SP)
MTC0	R30, 12, 0
LW	R30, 12(SP)
ADDIU	SP, SP, 16
WRPGPR	SP, SP
ERET	
; end of _UART1_Interrupt
_UART1_SetBaud:
;UART1.c,77 :: 		void UART1_SetBaud(void) {
;UART1.c,79 :: 		U1BRG = 520;
ORI	R2, R0, 520
SW	R2, Offset(U1BRG+0)(GP)
;UART1.c,80 :: 		}
L_end_UART1_SetBaud:
JR	RA
NOP	
; end of _UART1_SetBaud
_UART1_StartRx:
;UART1.c,84 :: 		void UART1_StartRx(void) {
;UART1.c,85 :: 		ON__U1MODE_bit = 1; // Enable UART1 circuit
LUI	R2, BitMask(ON__U1MODE_bit+0)
ORI	R2, R2, BitMask(ON__U1MODE_bit+0)
_SX	8, Offset(ON__U1MODE_bit+8), 4
;UART1.c,86 :: 		URXEN_bit = 1;      // Enable receiver
LUI	R2, BitMask(URXEN_bit+0)
ORI	R2, R2, BitMask(URXEN_bit+0)
_SX	8, Offset(URXEN_bit+8), 4
;UART1.c,88 :: 		U1IP0_bit = 0;      // Set UART1 priority
LUI	R2, BitMask(U1IP0_bit+0)
ORI	R2, R2, BitMask(U1IP0_bit+0)
_SX	8, Offset(U1IP0_bit+4), 4
;UART1.c,89 :: 		U1IP1_bit = 1;
LUI	R2, BitMask(U1IP1_bit+0)
ORI	R2, R2, BitMask(U1IP1_bit+0)
_SX	8, Offset(U1IP1_bit+8), 4
;UART1.c,90 :: 		U1IP2_bit = 1;
LUI	R2, BitMask(U1IP2_bit+0)
ORI	R2, R2, BitMask(U1IP2_bit+0)
_SX	8, Offset(U1IP2_bit+8), 4
;UART1.c,91 :: 		U1IS1_bit = 1;      // Set UART1 sub-priority
LUI	R2, BitMask(U1IS1_bit+0)
ORI	R2, R2, BitMask(U1IS1_bit+0)
_SX	8, Offset(U1IS1_bit+8), 4
;UART1.c,92 :: 		U1IS0_bit = 1;
LUI	R2, BitMask(U1IS0_bit+0)
ORI	R2, R2, BitMask(U1IS0_bit+0)
_SX	8, Offset(U1IS0_bit+8), 4
;UART1.c,94 :: 		URXISEL0_bit = 0;   // Interrupt when buffer is not empty
LUI	R2, BitMask(URXISEL0_bit+0)
ORI	R2, R2, BitMask(URXISEL0_bit+0)
_SX	8, Offset(URXISEL0_bit+4), 4
;UART1.c,95 :: 		URXISEL1_bit = 0;
LUI	R2, BitMask(URXISEL1_bit+0)
ORI	R2, R2, BitMask(URXISEL1_bit+0)
_SX	8, Offset(URXISEL1_bit+4), 4
;UART1.c,97 :: 		U1RXIF_bit = 0;     // Clear the receive interrupt flag
LUI	R2, BitMask(U1RXIF_bit+0)
ORI	R2, R2, BitMask(U1RXIF_bit+0)
_SX	8, Offset(U1RXIF_bit+4), 4
;UART1.c,98 :: 		U1RXIE_bit = 1;     // Enable receiver interrupts
LUI	R2, BitMask(U1RXIE_bit+0)
ORI	R2, R2, BitMask(U1RXIE_bit+0)
_SX	8, Offset(U1RXIE_bit+8), 4
;UART1.c,99 :: 		}
L_end_UART1_StartRx:
JR	RA
NOP	
; end of _UART1_StartRx
_UART1_StartTx:
;UART1.c,103 :: 		void UART1_StartTx(void) {
;UART1.c,104 :: 		UTXEN_bit = 1;      // Enable transmitter
LUI	R2, BitMask(UTXEN_bit+0)
ORI	R2, R2, BitMask(UTXEN_bit+0)
_SX	8, Offset(UTXEN_bit+8), 4
;UART1.c,106 :: 		UTXISEL0_bit = 0;   // Interrupt when transmit buffer is empty
LUI	R2, BitMask(UTXISEL0_bit+0)
ORI	R2, R2, BitMask(UTXISEL0_bit+0)
_SX	8, Offset(UTXISEL0_bit+4), 4
;UART1.c,107 :: 		UTXISEL1_bit = 1;
LUI	R2, BitMask(UTXISEL1_bit+0)
ORI	R2, R2, BitMask(UTXISEL1_bit+0)
_SX	8, Offset(UTXISEL1_bit+8), 4
;UART1.c,109 :: 		U1TXIF_bit = 0;     // Clear transmit interrupt flag
LUI	R2, BitMask(U1TXIF_bit+0)
ORI	R2, R2, BitMask(U1TXIF_bit+0)
_SX	8, Offset(U1TXIF_bit+4), 4
;UART1.c,110 :: 		U1TXIE_bit = 1;     // Enable transmitter interrupts
LUI	R2, BitMask(U1TXIE_bit+0)
ORI	R2, R2, BitMask(U1TXIE_bit+0)
_SX	8, Offset(U1TXIE_bit+8), 4
;UART1.c,111 :: 		}
L_end_UART1_StartTx:
JR	RA
NOP	
; end of _UART1_StartTx
_InitUART1:
;UART1.c,120 :: 		void InitUART1(void) {
ADDIU	SP, SP, -4
SW	RA, 0(SP)
;UART1.c,121 :: 		UART1_SetBaud();
JAL	_UART1_SetBaud+0
NOP	
;UART1.c,122 :: 		UART1_RxQueueInit();
JAL	_UART1_RxQueueInit+0
NOP	
;UART1.c,123 :: 		UART1_TxQueueInit();
JAL	_UART1_TxQueueInit+0
NOP	
;UART1.c,124 :: 		UART1_StartRx();
JAL	_UART1_StartRx+0
NOP	
;UART1.c,125 :: 		}
L_end_InitUART1:
LW	RA, 0(SP)
ADDIU	SP, SP, 4
JR	RA
NOP	
; end of _InitUART1
_UART1_TxQueueInit:
;UART1.c,129 :: 		void UART1_TxQueueInit(void) {
;UART1.c,130 :: 		TxQ.TxIn = 0;
SH	R0, Offset(_TxQ+0)(GP)
;UART1.c,131 :: 		TxQ.TxOut = 0;
SH	R0, Offset(_TxQ+2)(GP)
;UART1.c,132 :: 		XmtBufPtr = 0;
SB	R0, Offset(_XmtBufPtr+0)(GP)
;UART1.c,133 :: 		}
L_end_UART1_TxQueueInit:
JR	RA
NOP	
; end of _UART1_TxQueueInit
_UART1_RxQueueInit:
;UART1.c,137 :: 		void UART1_RxQueueInit(void) {
;UART1.c,138 :: 		RxQ.RxIn = 0;
SH	R0, Offset(_RxQ+0)(GP)
;UART1.c,139 :: 		RxQ.RxOut = 0;
SH	R0, Offset(_RxQ+2)(GP)
;UART1.c,140 :: 		RcvBufPtr = 0;
SB	R0, Offset(_RcvBufPtr+0)(GP)
;UART1.c,141 :: 		}
L_end_UART1_RxQueueInit:
JR	RA
NOP	
; end of _UART1_RxQueueInit
_UART1_SendMsg:
;UART1.c,145 :: 		void UART1_SendMsg(char *s) {
ADDIU	SP, SP, -4
SW	RA, 0(SP)
;UART1.c,146 :: 		XmtBuf = s;           // Pointer to the message for the UART1 interrupt handler
SW	R25, Offset(_XmtBuf+0)(GP)
;UART1.c,147 :: 		XmtBufPtr = 0;        // Set character counter to start of text message
SB	R0, Offset(_XmtBufPtr+0)(GP)
;UART1.c,148 :: 		UART1_StartTx();      // Turn on UART1 transmitter
JAL	_UART1_StartTx+0
NOP	
;UART1.c,149 :: 		}
L_end_UART1_SendMsg:
LW	RA, 0(SP)
ADDIU	SP, SP, 4
JR	RA
NOP	
; end of _UART1_SendMsg
_UART1_CheckQueue:
;UART1.c,156 :: 		void UART1_CheckQueue(void) {
ADDIU	SP, SP, -8
SW	RA, 0(SP)
;UART1.c,159 :: 		if ((!U1TXIE_bit)&&(TRMT_bit)) {
SW	R25, 4(SP)
_LX	, 4
EXT	R2, R2, BitPos(U1TXIE_bit+0), 1
BEQ	R2, R0, L__UART1_CheckQueue72
NOP	
J	L__UART1_CheckQueue58
NOP	
L__UART1_CheckQueue72:
_LX	, 4
EXT	R2, R2, BitPos(TRMT_bit+0), 1
BNE	R2, R0, L__UART1_CheckQueue74
NOP	
J	L__UART1_CheckQueue57
NOP	
L__UART1_CheckQueue74:
L__UART1_CheckQueue56:
;UART1.c,161 :: 		if (TxQ.TxIn != TxQ.TxOut) {       // If pointers are not the same
LH	R3, Offset(_TxQ+2)(GP)
LH	R2, Offset(_TxQ+0)(GP)
BNE	R2, R3, L__UART1_CheckQueue76
NOP	
J	L_UART1_CheckQueue8
NOP	
L__UART1_CheckQueue76:
;UART1.c,162 :: 		UART1_SendMsg(TxQ.TxQueue[TxQ.TxOut++]);  // Hand off the message pointer and increment counter
LH	R2, Offset(_TxQ+2)(GP)
SLL	R3, R2, 2
LUI	R2, #hi_addr(_TxQ+4)
ORI	R2, R2, #lo_addr(_TxQ+4)
ADDU	R2, R2, R3
LW	R25, 0(R2)
JAL	_UART1_SendMsg+0
NOP	
LH	R2, Offset(_TxQ+2)(GP)
ADDIU	R2, R2, 1
SH	R2, Offset(_TxQ+2)(GP)
;UART1.c,163 :: 		if (TxQ.TxOut > (txqsize-1))   // Check for wrap
SEH	R2, R2
SLTI	R2, R2, 32
BEQ	R2, R0, L__UART1_CheckQueue77
NOP	
J	L_UART1_CheckQueue9
NOP	
L__UART1_CheckQueue77:
;UART1.c,164 :: 		TxQ.TxOut = 0;
SH	R0, Offset(_TxQ+2)(GP)
L_UART1_CheckQueue9:
;UART1.c,165 :: 		} else {
J	L_UART1_CheckQueue10
NOP	
L_UART1_CheckQueue8:
;UART1.c,166 :: 		UART_Busy = FALSE;
SB	R0, Offset(_UART_Busy+0)(GP)
;UART1.c,167 :: 		}
L_UART1_CheckQueue10:
;UART1.c,159 :: 		if ((!U1TXIE_bit)&&(TRMT_bit)) {
L__UART1_CheckQueue58:
L__UART1_CheckQueue57:
;UART1.c,169 :: 		}
L_end_UART1_CheckQueue:
LW	R25, 4(SP)
LW	RA, 0(SP)
ADDIU	SP, SP, 8
JR	RA
NOP	
; end of _UART1_CheckQueue
_UART1_PutQueue:
;UART1.c,174 :: 		void UART1_PutQueue(char *msg) {
;UART1.c,175 :: 		TxQ.TxQueue[TxQ.TxIn++] = msg;      // Enter the message pointer into the queue
LH	R2, Offset(_TxQ+0)(GP)
SLL	R3, R2, 2
LUI	R2, #hi_addr(_TxQ+4)
ORI	R2, R2, #lo_addr(_TxQ+4)
ADDU	R2, R2, R3
SW	R25, 0(R2)
LH	R2, Offset(_TxQ+0)(GP)
ADDIU	R2, R2, 1
SH	R2, Offset(_TxQ+0)(GP)
;UART1.c,176 :: 		if (TxQ.TxIn > (txqsize-1))         // Check for wrap
SEH	R2, R2
SLTI	R2, R2, 32
BEQ	R2, R0, L__UART1_PutQueue79
NOP	
J	L_UART1_PutQueue11
NOP	
L__UART1_PutQueue79:
;UART1.c,177 :: 		TxQ.TxIn = 0;
SH	R0, Offset(_TxQ+0)(GP)
L_UART1_PutQueue11:
;UART1.c,179 :: 		UART_Busy = TRUE;
ORI	R2, R0, 1
SB	R2, Offset(_UART_Busy+0)(GP)
;UART1.c,180 :: 		}
L_end_UART1_PutQueue:
JR	RA
NOP	
; end of _UART1_PutQueue
_UART1_GetChar:
;UART1.c,186 :: 		char UART1_GetChar(char *rxbyte) {
;UART1.c,187 :: 		if (RxQ.RxIn != RxQ.RxOut){             // If pointers are not the same
LH	R3, Offset(_RxQ+2)(GP)
LH	R2, Offset(_RxQ+0)(GP)
BNE	R2, R3, L__UART1_GetChar82
NOP	
J	L_UART1_GetChar12
NOP	
L__UART1_GetChar82:
;UART1.c,188 :: 		*rxbyte = RxQ.RxQueue[RxQ.RxOut++];  // Fetch a character from the recirculating buffer
LH	R3, Offset(_RxQ+2)(GP)
LUI	R2, #hi_addr(_RxQ+4)
ORI	R2, R2, #lo_addr(_RxQ+4)
ADDU	R2, R2, R3
LBU	R2, 0(R2)
SB	R2, 0(R25)
LH	R2, Offset(_RxQ+2)(GP)
ADDIU	R2, R2, 1
SH	R2, Offset(_RxQ+2)(GP)
;UART1.c,189 :: 		if (RxQ.RxOut > (rxqsize-1))         // Check for wrap
SEH	R2, R2
SLTI	R2, R2, 64
BEQ	R2, R0, L__UART1_GetChar83
NOP	
J	L_UART1_GetChar13
NOP	
L__UART1_GetChar83:
;UART1.c,190 :: 		RxQ.RxOut = 0;
SH	R0, Offset(_RxQ+2)(GP)
L_UART1_GetChar13:
;UART1.c,191 :: 		return 1;
ORI	R2, R0, 1
J	L_end_UART1_GetChar
NOP	
;UART1.c,192 :: 		} else {
L_UART1_GetChar12:
;UART1.c,193 :: 		return 0;
MOVZ	R2, R0, R0
;UART1.c,195 :: 		}
L_end_UART1_GetChar:
JR	RA
NOP	
; end of _UART1_GetChar
_UART1_Rx:
;UART1.c,199 :: 		void UART1_Rx(void) {
ADDIU	SP, SP, -4
SW	RA, 0(SP)
;UART1.c,200 :: 		UART1_RxFuncPtr();        // Use the function pointer to go to a state
LW	R30, Offset(_UART1_RxFuncPtr+0)(GP)
JALR	RA, R30
NOP	
;UART1.c,201 :: 		}
L_end_UART1_Rx:
LW	RA, 0(SP)
ADDIU	SP, SP, 4
JR	RA
NOP	
; end of _UART1_Rx
_UART1_Rx1:
;UART1.c,206 :: 		void UART1_Rx1(void) {
ADDIU	SP, SP, -12
SW	RA, 0(SP)
;UART1.c,209 :: 		if (UART1_GetChar(&rxchar)) {
SW	R25, 4(SP)
ADDIU	R2, SP, 8
MOVZ	R25, R2, R0
JAL	_UART1_GetChar+0
NOP	
BNE	R2, R0, L__UART1_Rx187
NOP	
J	L_UART1_Rx115
NOP	
L__UART1_Rx187:
;UART1.c,210 :: 		switch (rxchar){
J	L_UART1_Rx116
NOP	
;UART1.c,211 :: 		case NUL:     // Discard NUL character
L_UART1_Rx118:
;UART1.c,212 :: 		break;
J	L_UART1_Rx117
NOP	
;UART1.c,214 :: 		case '\r':    // Discard return character
L_UART1_Rx119:
;UART1.c,215 :: 		break;
J	L_UART1_Rx117
NOP	
;UART1.c,217 :: 		case '\n':    // New line character
L_UART1_Rx120:
;UART1.c,218 :: 		RcvBuf[RcvBufPtr++] = rxchar;     // Put received character into buffer
LBU	R3, Offset(_RcvBufPtr+0)(GP)
LUI	R2, #hi_addr(_RcvBuf+0)
ORI	R2, R2, #lo_addr(_RcvBuf+0)
ADDU	R3, R2, R3
LBU	R2, 8(SP)
SB	R2, 0(R3)
LBU	R2, Offset(_RcvBufPtr+0)(GP)
ADDIU	R2, R2, 1
SB	R2, Offset(_RcvBufPtr+0)(GP)
;UART1.c,219 :: 		RcvBuf[RcvBufPtr] = 0;            // End marker
ANDI	R3, R2, 255
LUI	R2, #hi_addr(_RcvBuf+0)
ORI	R2, R2, #lo_addr(_RcvBuf+0)
ADDU	R2, R2, R3
SB	R0, 0(R2)
;UART1.c,220 :: 		RcvBufPtr = 0;                    // Point to start of buffer
SB	R0, Offset(_RcvBufPtr+0)(GP)
;UART1.c,221 :: 		UART1_RxFuncPtr = UART1_Rx2;      // Go to state 2
LUI	R2, #hi_addr(_UART1_Rx2+0)
ORI	R2, R2, #lo_addr(_UART1_Rx2+0)
SW	R2, Offset(_UART1_RxFuncPtr+0)(GP)
;UART1.c,222 :: 		break;
J	L_UART1_Rx117
NOP	
;UART1.c,224 :: 		default:
L_UART1_Rx121:
;UART1.c,225 :: 		if (RcvBufPtr < (RcvBufSize-2))   // Prevents buffer overrun
LBU	R2, Offset(_RcvBufPtr+0)(GP)
SLTIU	R2, R2, 62
BNE	R2, R0, L__UART1_Rx188
NOP	
J	L_UART1_Rx122
NOP	
L__UART1_Rx188:
;UART1.c,226 :: 		RcvBuf[RcvBufPtr++] = rxchar;  // Put character in buffer
LBU	R3, Offset(_RcvBufPtr+0)(GP)
LUI	R2, #hi_addr(_RcvBuf+0)
ORI	R2, R2, #lo_addr(_RcvBuf+0)
ADDU	R3, R2, R3
LBU	R2, 8(SP)
SB	R2, 0(R3)
LBU	R2, Offset(_RcvBufPtr+0)(GP)
ADDIU	R2, R2, 1
SB	R2, Offset(_RcvBufPtr+0)(GP)
L_UART1_Rx122:
;UART1.c,227 :: 		break;
J	L_UART1_Rx117
NOP	
;UART1.c,228 :: 		}
L_UART1_Rx116:
LBU	R2, 8(SP)
BNE	R2, R0, L__UART1_Rx190
NOP	
J	L_UART1_Rx118
NOP	
L__UART1_Rx190:
LBU	R3, 8(SP)
ORI	R2, R0, 13
BNE	R3, R2, L__UART1_Rx192
NOP	
J	L_UART1_Rx119
NOP	
L__UART1_Rx192:
LBU	R3, 8(SP)
ORI	R2, R0, 10
BNE	R3, R2, L__UART1_Rx194
NOP	
J	L_UART1_Rx120
NOP	
L__UART1_Rx194:
J	L_UART1_Rx121
NOP	
L_UART1_Rx117:
;UART1.c,229 :: 		}
L_UART1_Rx115:
;UART1.c,230 :: 		}
L_end_UART1_Rx1:
LW	R25, 4(SP)
LW	RA, 0(SP)
ADDIU	SP, SP, 12
JR	RA
NOP	
; end of _UART1_Rx1
_UART1_Rx2:
;UART1.c,234 :: 		void UART1_Rx2(void) {
ADDIU	SP, SP, -16
SW	RA, 0(SP)
;UART1.c,237 :: 		switch (RcvBuf[0]) {
SW	R25, 4(SP)
SW	R26, 8(SP)
SW	R27, 12(SP)
J	L_UART1_Rx223
NOP	
;UART1.c,241 :: 		case 'a':
L_UART1_Rx225:
;UART1.c,242 :: 		UART1_PutQueue("ACK\r\n");
LUI	R25, #hi_addr(?lstr1_UART1+0)
ORI	R25, R25, #lo_addr(?lstr1_UART1+0)
JAL	_UART1_PutQueue+0
NOP	
;UART1.c,243 :: 		break;
J	L_UART1_Rx224
NOP	
;UART1.c,245 :: 		case 'b':
L_UART1_Rx226:
;UART1.c,246 :: 		break;
J	L_UART1_Rx224
NOP	
;UART1.c,248 :: 		case 'c':
L_UART1_Rx227:
;UART1.c,249 :: 		break;
J	L_UART1_Rx224
NOP	
;UART1.c,251 :: 		case 'd':
L_UART1_Rx228:
;UART1.c,252 :: 		break;
J	L_UART1_Rx224
NOP	
;UART1.c,254 :: 		case 'e':
L_UART1_Rx229:
;UART1.c,255 :: 		break;
J	L_UART1_Rx224
NOP	
;UART1.c,257 :: 		case 'f':
L_UART1_Rx230:
;UART1.c,258 :: 		break;
J	L_UART1_Rx224
NOP	
;UART1.c,260 :: 		case 'g':
L_UART1_Rx231:
;UART1.c,261 :: 		break;
J	L_UART1_Rx224
NOP	
;UART1.c,263 :: 		case 'h':
L_UART1_Rx232:
;UART1.c,264 :: 		break;
J	L_UART1_Rx224
NOP	
;UART1.c,266 :: 		case 'i':
L_UART1_Rx233:
;UART1.c,267 :: 		break;
J	L_UART1_Rx224
NOP	
;UART1.c,269 :: 		case 'j':
L_UART1_Rx234:
;UART1.c,270 :: 		break;
J	L_UART1_Rx224
NOP	
;UART1.c,272 :: 		case 'k':
L_UART1_Rx235:
;UART1.c,273 :: 		break;
J	L_UART1_Rx224
NOP	
;UART1.c,275 :: 		case 'l':
L_UART1_Rx236:
;UART1.c,276 :: 		break;
J	L_UART1_Rx224
NOP	
;UART1.c,278 :: 		case 'm':
L_UART1_Rx237:
;UART1.c,279 :: 		break;
J	L_UART1_Rx224
NOP	
;UART1.c,281 :: 		case 'n':
L_UART1_Rx238:
;UART1.c,282 :: 		break;
J	L_UART1_Rx224
NOP	
;UART1.c,284 :: 		case 'o':
L_UART1_Rx239:
;UART1.c,285 :: 		break;
J	L_UART1_Rx224
NOP	
;UART1.c,287 :: 		case 'p':
L_UART1_Rx240:
;UART1.c,288 :: 		break;
J	L_UART1_Rx224
NOP	
;UART1.c,290 :: 		case 'q':
L_UART1_Rx241:
;UART1.c,291 :: 		break;
J	L_UART1_Rx224
NOP	
;UART1.c,293 :: 		case 'r':
L_UART1_Rx242:
;UART1.c,294 :: 		break;
J	L_UART1_Rx224
NOP	
;UART1.c,296 :: 		case 's':
L_UART1_Rx243:
;UART1.c,297 :: 		break;
J	L_UART1_Rx224
NOP	
;UART1.c,299 :: 		case 't':
L_UART1_Rx244:
;UART1.c,300 :: 		break;
J	L_UART1_Rx224
NOP	
;UART1.c,302 :: 		case 'u':
L_UART1_Rx245:
;UART1.c,303 :: 		break;
J	L_UART1_Rx224
NOP	
;UART1.c,305 :: 		case 'v':
L_UART1_Rx246:
;UART1.c,306 :: 		break;
J	L_UART1_Rx224
NOP	
;UART1.c,308 :: 		case 'w':
L_UART1_Rx247:
;UART1.c,309 :: 		if (OpenFile("Test1.txt")) {
LUI	R25, #hi_addr(?lstr2_UART1+0)
ORI	R25, R25, #lo_addr(?lstr2_UART1+0)
JAL	_OpenFile+0
NOP	
BNE	R2, R0, L__UART1_Rx297
NOP	
J	L_UART1_Rx248
NOP	
L__UART1_Rx297:
;UART1.c,311 :: 		while (ReadFile(FileDataBfr) == 0) {
L_UART1_Rx249:
LUI	R25, #hi_addr(_FileDataBfr+0)
ORI	R25, R25, #lo_addr(_FileDataBfr+0)
JAL	_ReadFile+0
NOP	
SEH	R2, R2
BEQ	R2, R0, L__UART1_Rx298
NOP	
J	L_UART1_Rx250
NOP	
L__UART1_Rx298:
;UART1.c,312 :: 		UART1_PutQueue(FileDataBfr);
LUI	R25, #hi_addr(_FileDataBfr+0)
ORI	R25, R25, #lo_addr(_FileDataBfr+0)
JAL	_UART1_PutQueue+0
NOP	
;UART1.c,314 :: 		while (UART_Busy == TRUE) {
L_UART1_Rx251:
LBU	R3, Offset(_UART_Busy+0)(GP)
ORI	R2, R0, 1
BEQ	R3, R2, L__UART1_Rx299
NOP	
J	L_UART1_Rx252
NOP	
L__UART1_Rx299:
;UART1.c,315 :: 		UART1_CheckQueue();
JAL	_UART1_CheckQueue+0
NOP	
;UART1.c,316 :: 		}
J	L_UART1_Rx251
NOP	
L_UART1_Rx252:
;UART1.c,317 :: 		}
J	L_UART1_Rx249
NOP	
L_UART1_Rx250:
;UART1.c,319 :: 		CloseFile();
JAL	_CloseFile+0
NOP	
;UART1.c,320 :: 		}
L_UART1_Rx248:
;UART1.c,321 :: 		break;
J	L_UART1_Rx224
NOP	
;UART1.c,323 :: 		case 'x':
L_UART1_Rx253:
;UART1.c,324 :: 		break;
J	L_UART1_Rx224
NOP	
;UART1.c,326 :: 		case 'y':
L_UART1_Rx254:
;UART1.c,327 :: 		Counter1 = 0;
SH	R0, Offset(_Counter1+0)(GP)
;UART1.c,328 :: 		memset(FileDataBfr,0,512);  // Clear the buffer
ORI	R27, R0, 512
MOVZ	R26, R0, R0
LUI	R25, #hi_addr(_FileDataBfr+0)
ORI	R25, R25, #lo_addr(_FileDataBfr+0)
JAL	_memset+0
NOP	
;UART1.c,329 :: 		Mmc_Fat_Dir(PrintChar);
LUI	R25, #hi_addr(_PrintChar+0)
ORI	R25, R25, #lo_addr(_PrintChar+0)
JAL	_Mmc_Fat_Dir+0
NOP	
;UART1.c,330 :: 		strcat(FileDataBfr,"\r\n");
LUI	R26, #hi_addr(?lstr3_UART1+0)
ORI	R26, R26, #lo_addr(?lstr3_UART1+0)
LUI	R25, #hi_addr(_FileDataBfr+0)
ORI	R25, R25, #lo_addr(_FileDataBfr+0)
JAL	_strcat+0
NOP	
;UART1.c,331 :: 		UART1_PutQueue(FileDataBfr);
LUI	R25, #hi_addr(_FileDataBfr+0)
ORI	R25, R25, #lo_addr(_FileDataBfr+0)
JAL	_UART1_PutQueue+0
NOP	
;UART1.c,332 :: 		break;
J	L_UART1_Rx224
NOP	
;UART1.c,341 :: 		default:
L_UART1_Rx255:
;UART1.c,342 :: 		UART1_PutQueue("Unknown command: ");
LUI	R25, #hi_addr(?lstr4_UART1+0)
ORI	R25, R25, #lo_addr(?lstr4_UART1+0)
JAL	_UART1_PutQueue+0
NOP	
;UART1.c,344 :: 		BufNum = GetBuffer();   // Get a free buffer
JAL	_GetBuffer+0
NOP	
; BufNum start address is: 80 (R20)
MOVZ	R20, R2, R0
;UART1.c,345 :: 		(void)sprintf(BufNum,"%c\r\n",RcvBuf[0]);
LUI	R4, #hi_addr(?lstr_5_UART1+0)
ORI	R4, R4, #lo_addr(?lstr_5_UART1+0)
LBU	R3, Offset(_RcvBuf+0)(GP)
ADDIU	SP, SP, -12
SB	R3, 8(SP)
SW	R4, 4(SP)
SW	R2, 0(SP)
JAL	_sprintf+0
NOP	
ADDIU	SP, SP, 12
;UART1.c,346 :: 		UART1_PutQueue(BufNum);
MOVZ	R25, R20, R0
; BufNum end address is: 80 (R20)
JAL	_UART1_PutQueue+0
NOP	
;UART1.c,347 :: 		break;
J	L_UART1_Rx224
NOP	
;UART1.c,348 :: 		}
L_UART1_Rx223:
LBU	R3, Offset(_RcvBuf+0)(GP)
ORI	R2, R0, 97
BNE	R3, R2, L__UART1_Rx2101
NOP	
J	L_UART1_Rx225
NOP	
L__UART1_Rx2101:
LBU	R3, Offset(_RcvBuf+0)(GP)
ORI	R2, R0, 98
BNE	R3, R2, L__UART1_Rx2103
NOP	
J	L_UART1_Rx226
NOP	
L__UART1_Rx2103:
LBU	R3, Offset(_RcvBuf+0)(GP)
ORI	R2, R0, 99
BNE	R3, R2, L__UART1_Rx2105
NOP	
J	L_UART1_Rx227
NOP	
L__UART1_Rx2105:
LBU	R3, Offset(_RcvBuf+0)(GP)
ORI	R2, R0, 100
BNE	R3, R2, L__UART1_Rx2107
NOP	
J	L_UART1_Rx228
NOP	
L__UART1_Rx2107:
LBU	R3, Offset(_RcvBuf+0)(GP)
ORI	R2, R0, 101
BNE	R3, R2, L__UART1_Rx2109
NOP	
J	L_UART1_Rx229
NOP	
L__UART1_Rx2109:
LBU	R3, Offset(_RcvBuf+0)(GP)
ORI	R2, R0, 102
BNE	R3, R2, L__UART1_Rx2111
NOP	
J	L_UART1_Rx230
NOP	
L__UART1_Rx2111:
LBU	R3, Offset(_RcvBuf+0)(GP)
ORI	R2, R0, 103
BNE	R3, R2, L__UART1_Rx2113
NOP	
J	L_UART1_Rx231
NOP	
L__UART1_Rx2113:
LBU	R3, Offset(_RcvBuf+0)(GP)
ORI	R2, R0, 104
BNE	R3, R2, L__UART1_Rx2115
NOP	
J	L_UART1_Rx232
NOP	
L__UART1_Rx2115:
LBU	R3, Offset(_RcvBuf+0)(GP)
ORI	R2, R0, 105
BNE	R3, R2, L__UART1_Rx2117
NOP	
J	L_UART1_Rx233
NOP	
L__UART1_Rx2117:
LBU	R3, Offset(_RcvBuf+0)(GP)
ORI	R2, R0, 106
BNE	R3, R2, L__UART1_Rx2119
NOP	
J	L_UART1_Rx234
NOP	
L__UART1_Rx2119:
LBU	R3, Offset(_RcvBuf+0)(GP)
ORI	R2, R0, 107
BNE	R3, R2, L__UART1_Rx2121
NOP	
J	L_UART1_Rx235
NOP	
L__UART1_Rx2121:
LBU	R3, Offset(_RcvBuf+0)(GP)
ORI	R2, R0, 108
BNE	R3, R2, L__UART1_Rx2123
NOP	
J	L_UART1_Rx236
NOP	
L__UART1_Rx2123:
LBU	R3, Offset(_RcvBuf+0)(GP)
ORI	R2, R0, 109
BNE	R3, R2, L__UART1_Rx2125
NOP	
J	L_UART1_Rx237
NOP	
L__UART1_Rx2125:
LBU	R3, Offset(_RcvBuf+0)(GP)
ORI	R2, R0, 110
BNE	R3, R2, L__UART1_Rx2127
NOP	
J	L_UART1_Rx238
NOP	
L__UART1_Rx2127:
LBU	R3, Offset(_RcvBuf+0)(GP)
ORI	R2, R0, 111
BNE	R3, R2, L__UART1_Rx2129
NOP	
J	L_UART1_Rx239
NOP	
L__UART1_Rx2129:
LBU	R3, Offset(_RcvBuf+0)(GP)
ORI	R2, R0, 112
BNE	R3, R2, L__UART1_Rx2131
NOP	
J	L_UART1_Rx240
NOP	
L__UART1_Rx2131:
LBU	R3, Offset(_RcvBuf+0)(GP)
ORI	R2, R0, 113
BNE	R3, R2, L__UART1_Rx2133
NOP	
J	L_UART1_Rx241
NOP	
L__UART1_Rx2133:
LBU	R3, Offset(_RcvBuf+0)(GP)
ORI	R2, R0, 114
BNE	R3, R2, L__UART1_Rx2135
NOP	
J	L_UART1_Rx242
NOP	
L__UART1_Rx2135:
LBU	R3, Offset(_RcvBuf+0)(GP)
ORI	R2, R0, 115
BNE	R3, R2, L__UART1_Rx2137
NOP	
J	L_UART1_Rx243
NOP	
L__UART1_Rx2137:
LBU	R3, Offset(_RcvBuf+0)(GP)
ORI	R2, R0, 116
BNE	R3, R2, L__UART1_Rx2139
NOP	
J	L_UART1_Rx244
NOP	
L__UART1_Rx2139:
LBU	R3, Offset(_RcvBuf+0)(GP)
ORI	R2, R0, 117
BNE	R3, R2, L__UART1_Rx2141
NOP	
J	L_UART1_Rx245
NOP	
L__UART1_Rx2141:
LBU	R3, Offset(_RcvBuf+0)(GP)
ORI	R2, R0, 118
BNE	R3, R2, L__UART1_Rx2143
NOP	
J	L_UART1_Rx246
NOP	
L__UART1_Rx2143:
LBU	R3, Offset(_RcvBuf+0)(GP)
ORI	R2, R0, 119
BNE	R3, R2, L__UART1_Rx2145
NOP	
J	L_UART1_Rx247
NOP	
L__UART1_Rx2145:
LBU	R3, Offset(_RcvBuf+0)(GP)
ORI	R2, R0, 120
BNE	R3, R2, L__UART1_Rx2147
NOP	
J	L_UART1_Rx253
NOP	
L__UART1_Rx2147:
LBU	R3, Offset(_RcvBuf+0)(GP)
ORI	R2, R0, 121
BNE	R3, R2, L__UART1_Rx2149
NOP	
J	L_UART1_Rx254
NOP	
L__UART1_Rx2149:
J	L_UART1_Rx255
NOP	
L_UART1_Rx224:
;UART1.c,349 :: 		UART1_RxFuncPtr = UART1_Rx1;    // Go back to state 1
LUI	R2, #hi_addr(_UART1_Rx1+0)
ORI	R2, R2, #lo_addr(_UART1_Rx1+0)
SW	R2, Offset(_UART1_RxFuncPtr+0)(GP)
;UART1.c,350 :: 		}
L_end_UART1_Rx2:
LW	R27, 12(SP)
LW	R26, 8(SP)
LW	R25, 4(SP)
LW	RA, 0(SP)
ADDIU	SP, SP, 16
JR	RA
NOP	
; end of _UART1_Rx2
_PrintChar:
;UART1.c,352 :: 		void PrintChar(char Ch) {
;UART1.c,353 :: 		FileDataBfr[Counter1++] = Ch;
LH	R3, Offset(_Counter1+0)(GP)
LUI	R2, #hi_addr(_FileDataBfr+0)
ORI	R2, R2, #lo_addr(_FileDataBfr+0)
ADDU	R2, R2, R3
SB	R25, 0(R2)
LH	R2, Offset(_Counter1+0)(GP)
ADDIU	R2, R2, 1
SH	R2, Offset(_Counter1+0)(GP)
;UART1.c,354 :: 		}
L_end_PrintChar:
JR	RA
NOP	
; end of _PrintChar
